﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Web.DynamicData;

public partial class FileImage : FieldTemplateUserControl {
    private int _ImageWidth = -1;
    private int _ImageHeight = -1;

    public int ImageWidth {
        get { return _ImageWidth; }
        set { _ImageWidth = value; }
    }

    public int ImageHeight {
        get { return _ImageHeight; }
        set { _ImageHeight = value; }
    }

    protected override void OnDataBinding(EventArgs e) {
        base.OnDataBinding(e);

        //check if image exists
        if (FieldValue == null) {
            return;
        }

        //format image url
        string url;
        var metadata = MetadataAttributes.OfType<DbImageAPI.ImageUrlAttribute>().FirstOrDefault();
        if (metadata != null) {
            url = string.Format(metadata.UrlFormat, FieldValueString);
        } else {
            url = FieldValueString;
        }
        Image1.ImageUrl = url;

        int width = -1;
        int height = -1;
        var imageformat = MetadataAttributes.OfType<DbImageAPI.ImageFormatAttribute>().FirstOrDefault();
        if (imageformat != null) {
            width = imageformat.DisplayWidth;
            height = imageformat.DisplayHeight;
        }

        if (ImageWidth != -1) {
            Image1.Width = ImageWidth;
        } else if (width != -1) {
            Image1.Width = width;
        }

        if (ImageHeight != -1) {
            Image1.Height = ImageHeight;
        } else if (height != -1) {
            Image1.Height = height;
        }
    }

}
